package com.sun.beans.decoder;

import java.lang.reflect.Array;

final class ArrayElementHandler extends NewElementHandler
{
    private Integer length;
    
    ArrayElementHandler() {
    }
    
    @Override
    public void addAttribute(String s, String s2) {
        if (s.equals("length")) {
            this.length = Integer.valueOf(s2);
        }
        else {
            super.addAttribute(s, s2);
        }
    }
    
    @Override
    public void startElement() {
        if (this.length != null) {
            super.getValueObject();
        }
    }
    
    @Override
    protected boolean isArgument() {
        return true;
    }
    
    protected ValueObject getValueObject(Class<?> clazz, Object[] array) {
        if (clazz == null) {
            clazz = Object.class;
        }
        if (this.length != null) {
            return ValueObjectImpl.create(Array.newInstance(clazz, (int)this.length));
        }
        Object instance = Array.newInstance(clazz, array.length);
        for (int i = 0; i < array.length; ++i) {
            Array.set(instance, i, array[i]);
        }
        return ValueObjectImpl.create(instance);
    }
}
